/*
              *****************************************************************************
              *  Copyright (C) by Reinhard Heuberger                                 *
              *                                                                           *
              *  All rights reserved.                                                     *
              *                                                                           *
              *  Redistribution and use in source and binary forms, with or without       *
              *  modification, are permitted provided that the following conditions       *
              *  are met:                                                                 *
              *                                                                           *
              *  1. Redistributions of source code must retain the above copyright        *
              *     notice, this list of conditions and the following disclaimer.         *
              *  2. Redistributions in binary form must reproduce the above copyright     *
              *     notice, this list of conditions and the following disclaimer in the   *
              *     documentation and/or other materials provided with the distribution.  *
              *  3. Neither the name of the author nor the names of its contributors may  *
              *     be used to endorse or promote products derived from this software     *
              *     without specific prior written permission.                            *
              *                                                                           *
              *****************************************************************************
*/
//
//
//
module  Cylinder(
		Enable,
      CLK_FPGA,             // Input Clock  23.04 MHz
      Restore,
		Strobe,
		cyl0i,
		cyl1i,
		cyl2i,
		cyl3i,
		cyl4i,
		cyl5i,
		cyl6i,
		cyl7i,
		//
		cyl0o,
		cyl1o,
		cyl2o,
		cyl3o,
		cyl4o,
		cyl5o,
		cyl6o,
		cyl7o);
		//
input	CLK_FPGA, Enable, Strobe, Restore;
input	cyl0i, cyl1i, cyl2i, cyl3i;
input	cyl4i, cyl5i, cyl6i, cyl7i;
        //
output  cyl0o, cyl1o, cyl2o, cyl3o;
output  cyl4o, cyl5o, cyl6o, cyl7o;
//
reg Strobe_p, nix;
reg  cyl0o, cyl1o, cyl2o, cyl3o;
reg  cyl4o, cyl5o, cyl6o, cyl7o;
wire strobe_puls;
//
always @ (posedge CLK_FPGA)
begin
    Strobe_p <= ~Strobe;
end
assign strobe_puls = Strobe & !Strobe_p;
//
always @ (posedge CLK_FPGA)
begin
    if(Restore) begin 
		cyl0o <= 0;
		cyl1o <= 0;
		cyl2o <= 0;
		cyl3o <= 0;
		cyl4o <= 0;
		cyl5o <= 0;
		cyl6o <= 0;
		cyl7o <= 0;	
	end else if (strobe_puls) begin
		cyl0o <= ~cyl0i;
		cyl1o <= ~cyl1i;
		cyl2o <= ~cyl2i;
		cyl3o <= ~cyl3i;
		cyl4o <= ~cyl4i;
		cyl5o <= ~cyl5i;
		cyl6o <= ~cyl6i;
		cyl7o <= ~cyl7i;
	end else begin
		nix <=nix;
	end
end
//
endmodule
       