/*
      *****************************************************************************
      *  Copyright (C)  by Reinhard Heuberger                                     *
      *                                                                           *
      *  All rights reserved.                                                     *
      *                                                                           *
      *  Redistribution and use in source and binary forms, with or without       *
      *  modification, are permitted provided that the following conditions       *
      *  are met:                                                                 *
      *                                                                           *
      *  1. Redistributions of source code must retain the above copyright        *
      *     notice, this list of conditions and the following disclaimer.         *
      *  2. Redistributions in binary form must reproduce the above copyright     *
      *     notice, this list of conditions and the following disclaimer in the   *
      *     documentation and/or other materials provided with the distribution.  *
      *  3. Neither the name of the author nor the names of its contributors may  *
      *     be used to endorse or promote products derived from this software     *
      *     without specific prior written permission.                            *
      *                                                                           *
      *****************************************************************************
*/
//
//
//
//
module drive_select(
       enable,              // Enable
       CLK_FPGA,            // Clock
       Drive0_in,           //-
       Drive1_in,           //-
       Drive2_in,           //-
       Drive3_in,           //-				 
       Drive0_set,          ///
       Drive1_set,          ////
		 Drive2_set,          /////
		 Drive3_set,          //////-> Dip Switch
		 match0_H,
		 match1_H,
		 match2_H,
		 match3_H,
       match_H);            //
//
input  enable, CLK_FPGA;
input  Drive0_in, Drive1_in, Drive2_in, Drive3_in;
input  Drive0_set, Drive1_set, Drive2_set, Drive3_set;
output match0_H, match1_H, match2_H, match3_H;
output match_H;
//
reg match_H, match0_H, match1_H, match2_H, match3_H; 
//
initial
begin
	match0_H <= 0;
   match1_H <= 0;
   match2_H <= 0;
   match3_H <= 0;
   match_H  <= 0;
end
//
always @ (posedge CLK_FPGA)
begin
  if(enable)begin
    //if(Drive0_set && Drive1_in && Drive0_in)         // drive 0
	 if(Drive0_set && Drive0_in)         // drive 0
	   begin
	    match0_H <= 1;
		 match1_H <= 0;
		 match2_H <= 0;
		 match3_H <= 0;
		 match_H  <= 1;
		end
	 //else if(Drive1_set && Drive1_in && !Drive0_in)   // drive 1
	 else if(Drive1_set && Drive1_in)                   // drive 1
	   begin
	    match0_H <= 0;
		 match1_H <= 1;
		 match2_H <= 0;
		 match3_H <= 0;
		 match_H  <= 1;
		end
	 //else if(Drive2_set && !Drive1_in && Drive0_in)    // drive 2
	 else if(Drive2_set && Drive2_in)                  // drive 2
	   begin
	    match0_H <= 0;
		 match1_H <= 0;
		 match2_H <= 1;
		 match3_H <= 0;
		 match_H  <= 1;		
		end
	 //else if(Drive3_set && !Drive1_in && !Drive0_in)   // drive 3
	 else if(Drive3_set && Drive3_in)                  // drive 3
	   begin
	    match0_H <= 0;
		 match1_H <= 0;
		 match2_H <= 0;
		 match3_H <= 1;
		 match_H  <= 1;
		end
	 else 
	    match_H <= 0;
  end else begin
    match_H <= 0;
  end
end
//
endmodule
